function P = get_reference_alloc(bits)
%
% P = get_reference_alloc(bits)
%
% Gets the allocation matrix, i.e. the assignment of reference bits for
% each coefficient of the 8x8 px DCT spectrum.
% 
% Input Parameters:
%
%   - bits - the total desired number of reference bits per block
%
% Output:
% 
% P - the bits allocation matrix
%
% ------------------------------------------------------------------------
%
% Copyright (C) 2011 Paweł Korus <pkorus@agh.edu.pl>
%
% Version: 2011.12.16
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation version 3.0.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
    P = zeros(8);
    p = [8 8 6 6 5 4 3 3
         8 6 6 5 4 3 3 0
         6 6 5 4 3 3 0 0
         6 5 4 3 3 0 0 0
         5 4 3 3 0 0 0 0
         4 3 3 0 0 0 0 0
         3 3 0 0 0 0 0 0
         3 0 0 0 0 0 0 0];
     indices = zigzag(8);
     ci = 1;
     for b = 1:bits
         if P(indices(ci)) >= p(indices(ci))
             ci = ci + 1;
         end
         P(indices(ci)) = P(indices(ci)) + 1;
     end

end